#!BPY

"""
Name: 'Malla Snap'
Blender: 242
Group: 'Mesh'
Tooltip: 'Crea Malla (Mesh) utilizando Snap.'
"""
#################################################
# Importacion de los modulos
#################################################

import Blender
from Blender import Window, Mesh, Mathutils, Scene
from Blender.BGL import *
from Blender.Draw import *
from Blender.Mathutils import *


import math 
from math import *

# Abertura seleccion (distancia maxima entre punto y arista)
Abertura=10			

# Events
EVENT_NOEVENT =1
EVENT_OK=2
EVENT_CANCEL=3
EVENT_Plano0=4
EVENT_Plano1=5
EVENT_Plano2=6
EVENT_Plano3=7
EVENT_Modo0=8
EVENT_Modo1=9
EVENT_Modo1_A =11
EVENT_Modo1_A0=12
EVENT_Modo1_A1=13
EVENT_Modo1_A2=14
EVENT_Modo1_A3=15
EVENT_Modo1_B =16
EVENT_Modo1_B0=17
EVENT_Modo1_B1=18
EVENT_Modo1_B2=19
EVENT_Modo1_B3=20
EVENT_Modo1_C0=21

EVENT_PTO_XYZ=22
EVENT_DISTANCIA=24
EVENT_ARISTA_BORRAR=25
EVENT_ARISTA_AGREGAR=26
EVENT_ARISTA_BO_NO=27
EVENT_ARISTA_BO_SI=28

I_Plano0= Create(0)
I_Plano1= Create(0)
I_Plano2= Create(0)
I_Plano3= Create(1)
I_Modo0=Create(1)
I_Modo1=Create(0)
S_Des_X = Create("")
S_Des_Y = Create("")
S_Des_Z = Create("")
S_Des_Dis = Create("")
S_Des_X.val="0.00"
S_Des_Y.val="0.00"
S_Des_Z.val="0.00"
S_Des_Dis.val="0.00"
I_Modo1_A =Create(0)
I_Modo1_A0=Create(0)
I_Modo1_A1=Create(0)
I_Modo1_A2=Create(0)
I_Modo1_A3=Create(0)
I_Modo1_B =Create(0)
I_Modo1_B0=Create(0)
I_Modo1_B1=Create(0)
I_Modo1_B2=Create(0)
I_Modo1_B3=Create(0)
I_Modo1_C0=Create(0)
S_Distan=Create("")
S_Distan.val="0.00"
S_Nombre=Create("")
S_Nombre.val="xxx"
I_Arista_Bo_No=Create(1)
I_Arista_Bo_Si=Create(0)


# Vertice Inicial
vDX=vDY=vDZ=0
Ver_X1,Ver_Y1,Ver_Z1= Window.GetCursorPos()
Ver_X2=Ver_X3D=Ver_X1
Ver_Y2=Ver_Y3D=Ver_Y1
Ver_Z2=Ver_Z3D=Ver_Z1
Ver_X3=Ver_X5=0
Ver_Y3=Ver_Y5=0
Ver_Z3=Ver_Z5=0
Ver_X4=Ver_X6=1
Ver_Y4=Ver_Y6=1
Ver_Z4=Ver_Z6=1

# Variables
I_Error_Sel=0

# Crear Malla
Window.EditMode(0)
MallaC = Mesh.New('Malla')
MallaC.verts.extend(Ver_X1,Ver_Y1,Ver_Z1)
scn = Scene.GetCurrent()
scn.objects.selected= [] 
obMallaC = scn.objects.new(MallaC, 'Malla')
I_Vert_Last=0
S_Nombre.val=obMallaC.name

Window.RedrawAll()

m_MatPerp=Window.GetPerspMatrix()
m_MatView=Window.GetViewMatrix()
w_minX=w_minY=w_maxX=w_maxY=0

print "==============================================================="


#################################################
# Dibujando el GUI
#################################################

def draw ():
	global EVENT_NOEVENT,EVENT_OK,EVENT_CANCEL
	global EVENT_ARISTA_AGREGAR,EVENT_ARISTA_BORRAR
	global EVENT_ARISTA_INICIAL_BORRAR_SI,EVENT_ARISTA_INICIAL_BORRAR_NO
	global EVENT_Plano0,EVENT_Plano1,EVENT_Plano2,EVENT_Plano3
	global EVENT_Modo0,EVENT_Modo1
	global EVENT_PTO_XYZ,EVENT_DISTANCIA
	global EVENT_Modo1_A,EVENT_Modo1_A0,EVENT_Modo1_A1,EVENT_Modo1_A2,EVENT_Modo1_A3
	global EVENT_Modo1_B,EVENT_Modo1_B0,EVENT_Modo1_B1,EVENT_Modo1_B2,EVENT_Modo1_B3
	global EVENT_Modo1_C0
	global EVENT_ARISTA_BO_NO,EVENT_ARISTA_BO_SI
	global I_Plano0,I_Plano1,I_Plano2,I_Plano3
	global I_Modo0,I_Modo1
	global S_Des_X,S_Des_Y,S_Des_Z
	global I_Modo1_A,I_Modo1_A0,I_Modo1_A1,I_Modo1_A2,I_Modo1_A3
	global I_Modo1_B,I_Modo1_B0,I_Modo1_B1,I_Modo1_B2,I_Modo1_B3
	global I_Modo1_C0
	global S_Des_Dis,S_Nombre
	global I_Arista_Bo_No,I_Arista_Bo_Si

	
	#########  Titles
	glClear(GL_COLOR_BUFFER_BIT)
	glRasterPos2d(8,415)
	Text("Malla - SNAP - Arista ")

	####### Planos
	Blender.BGL.glColor3f(0,0,0)
	Blender.BGL.glRasterPos2i(8,395)
	Blender.Draw.Text("Planos")
	Blender.BGL.glBegin(Blender.BGL.GL_LINE_STRIP)
	Blender.BGL.glVertex2i(5,400)
	Blender.BGL.glVertex2i(5,360)
	Blender.BGL.glVertex2i(300,360)
	Blender.BGL.glVertex2i(300,400)
	Blender.BGL.glVertex2i(50,400)
	Blender.BGL.glEnd()
	I_Plano3=Toggle("XYZ",EVENT_Plano3,20,370,50,18,I_Plano3.val,"Plano XYZ")
	I_Plano0=Toggle("XY",EVENT_Plano0,90,370,50,18,I_Plano0.val,"Plano XY")
	I_Plano1=Toggle("XZ",EVENT_Plano1,160,370,50,18,I_Plano1.val,"Plano XZ")
	I_Plano2=Toggle("YZ",EVENT_Plano2,230,370,50,18,I_Plano2.val,"Plano XY")
	
	####### Modos
	Blender.BGL.glRasterPos2i(8,345)
	Blender.Draw.Text("Modos")
	Blender.BGL.glBegin(Blender.BGL.GL_LINE_STRIP)
	Blender.BGL.glVertex2i(5,350)
	Blender.BGL.glVertex2i(5,310)
	Blender.BGL.glVertex2i(300,310)
	Blender.BGL.glVertex2i(300,350)
	Blender.BGL.glVertex2i(50,350)
	Blender.BGL.glEnd()
	I_Modo0=Toggle("Coordenadas",EVENT_Modo0,40,320,80,18,I_Modo0.val,"Vertices por Coordenadas")
	I_Modo1=Toggle("Seleccion",EVENT_Modo1,170,320,80,18,I_Modo1.val,"Vertices por Referencias con Objetos")
	
	####### Marco Opciones Modo
	Blender.BGL.glBegin(Blender.BGL.GL_LINE_STRIP)
	Blender.BGL.glVertex2i(5,300)
	Blender.BGL.glVertex2i(5,215)
	Blender.BGL.glVertex2i(300,215)
	Blender.BGL.glVertex2i(300,300)
	Blender.BGL.glVertex2i(5,300)
	Blender.BGL.glEnd()
	
	####### Desplazamientos
	if(I_Modo0.val==1):
		glRasterPos2d(10,275)
		if(I_Plano2.val != 1):
			Text("Dx:")
			S_Des_X= String("",EVENT_NOEVENT,35,275,85,18,
					S_Des_X.val,15,"Desplazamiento Eje X")
		if(I_Plano1.val != 1):
			glRasterPos2d(10,250)
			Text("Dy:")
			S_Des_Y= String("",EVENT_NOEVENT,35,250,85,18,
				S_Des_Y.val,15,"Desplazamiento Eje Y")
		if(I_Plano0.val != 1):
			glRasterPos2d(10,225)
			Text("Dz:")
			S_Des_Z= String("",EVENT_NOEVENT,35,225,85,18,
				S_Des_Z.val,15,"Desplazamiento Eje Z")
		Button("Pto Ref",EVENT_PTO_XYZ,225,275,60,18)

	####### Referencias Objetos
	if(I_Modo1.val==1):
		I_Modo1_A =Toggle("Arista 1",EVENT_Modo1_A,10,275,60,18,I_Modo1_A.val,"Buscar Borde 1")
		I_Modo1_A0=Toggle("V1",EVENT_Modo1_A0,100,275,40,18,I_Modo1_A0.val,"Vertice 1")
		I_Modo1_A1=Toggle("V2",EVENT_Modo1_A1,150,275,40,18,I_Modo1_A1.val,"Vertice 2")
		I_Modo1_A2=Toggle("M",EVENT_Modo1_A2,200,275,40,18,I_Modo1_A2.val,"Punto Medio")
		I_Modo1_A3=Toggle("P",EVENT_Modo1_A3,250,275,40,18,I_Modo1_A3.val,"Perpendicular")
		I_Modo1_B =Toggle("Arista 2",EVENT_Modo1_B,10,250,60,18,I_Modo1_B.val,"Buscar Borde 2")
		I_Modo1_B0=Toggle("V1",EVENT_Modo1_B0,100,250,40,18,I_Modo1_B0.val,"Vertice 1")
		I_Modo1_B1=Toggle("V2",EVENT_Modo1_B1,150,250,40,18,I_Modo1_B1.val,"Vertice 2")
		I_Modo1_B2=Toggle("M",EVENT_Modo1_B2,200,250,40,18,I_Modo1_B2.val,"Punto Medio")
		I_Modo1_B3=Toggle("P",EVENT_Modo1_B3,250,250,40,18,I_Modo1_B3.val,"Perpendicular")
		I_Modo1_C0=Toggle("I",EVENT_Modo1_C0,250,225,40,18,I_Modo1_C0.val,"Interseccion")

	####### Distancia
	Blender.BGL.glBegin(Blender.BGL.GL_LINE_STRIP)
	Blender.BGL.glVertex2i(5,200)
	Blender.BGL.glVertex2i(5,165)
	Blender.BGL.glVertex2i(300,165)
	Blender.BGL.glVertex2i(300,200)
	Blender.BGL.glVertex2i(5,200)
	Blender.BGL.glEnd()
	glRasterPos2d(10,180)
	Text("Distancia:")
	S_Des_Dis= String("",EVENT_NOEVENT,80,175,90,18,
			S_Des_Dis.val,15,"Distancia entre Vertices")
	Button("Pto",EVENT_DISTANCIA,225,175,60,18)
	

	####### Arista Agregar - Borrar
	Blender.BGL.glBegin(Blender.BGL.GL_LINE_STRIP)
	Blender.BGL.glVertex2i(5,155)
	Blender.BGL.glVertex2i(5,115)
	Blender.BGL.glVertex2i(300,115)
	Blender.BGL.glVertex2i(300,155)
	Blender.BGL.glVertex2i(55,155)
	Blender.BGL.glEnd()
	glRasterPos2d(10,150)
	Text("Arista")
	Button("Agregar",EVENT_ARISTA_AGREGAR,40,125,80,18)
	Button("Borrar",EVENT_ARISTA_BORRAR,170,125,80,18)

	####### Varios
	Blender.BGL.glBegin(Blender.BGL.GL_LINE_STRIP)
	Blender.BGL.glVertex2i(5,105)
	Blender.BGL.glVertex2i(5,40)
	Blender.BGL.glVertex2i(300,40)
	Blender.BGL.glVertex2i(300,105)
	Blender.BGL.glVertex2i(5,105)
	Blender.BGL.glEnd()
	glRasterPos2d(10,85)
	Text("Nombre Objeto:")
	S_Nombre= String("",EVENT_NOEVENT,140,80,90,18,
			S_Nombre.val,15,"Nombre Objeto")
	glRasterPos2d(10,60)
	Text("Borrar Arista Inicial:")
	I_Arista_Bo_No =Toggle("No",EVENT_ARISTA_BO_NO,140,55,60,18,I_Arista_Bo_No.val,"No Borrar Arista Inicial")
	I_Arista_Bo_Si =Toggle("Si",EVENT_ARISTA_BO_SI,220,55,60,18,I_Arista_Bo_Si.val,"Borrar Arista Inicial")
	
	####### Aceptar y Cancelar Buttons
	Button("Aceptar",EVENT_OK,40,10,80,18)
	Button("Cancelar",EVENT_CANCEL,170,10,80,18)

#--------------------------------------------------------------------------

def event(evt,val):

	if(evt == QKEY and not val):
		Exit()

#--------------------------------------------------------------------------

def bevent(evt):
	global EVENT_NOEVENT,EVENT_OK,EVENT_CANCEL
	global EVENT_ARISTA_AGREGAR,EVENT_ARISTA_BORRAR
	global EVENT_ARISTA_INICIAL_BORRAR_SI,EVENT_ARISTA_INICIAL_BORRAR_NO
	global EVENT_Plano0,EVENT_Plano1,EVENT_Plano2,EVENT_Plano3
	global EVENT_Modo0,EVENT_Modo1
	global EVENT_PTO_XYZ,EVENT_DISTANCIA
	global EVENT_Modo1_A,EVENT_Modo1_A0,EVENT_Modo1_A1,EVENT_Modo1_A2,EVENT_Modo1_A3
	global EVENT_Modo1_B,EVENT_Modo1_B0,EVENT_Modo1_B1,EVENT_Modo1_B2,EVENT_Modo1_B3
	global EVENT_Modo1_C0
	global EVENT_ARISTA_BO_NO,EVENT_ARISTA_BO_SI
	
	##### Manages GUI Events
	if(evt == EVENT_Plano0): plano_opcion(0)
	elif(evt == EVENT_Plano1): plano_opcion(1)
	elif(evt == EVENT_Plano2): plano_opcion(2)
	elif(evt == EVENT_Plano3): plano_opcion(3)

	elif(evt == EVENT_Modo0): modo_opcion(0)
	elif(evt == EVENT_Modo1): modo_opcion(1)

	elif(evt == EVENT_PTO_XYZ): pto_xyz()

	elif(evt == EVENT_Modo1_A): aristaA()
	elif(evt == EVENT_Modo1_A0): aristaA_opcion(0)
	elif(evt == EVENT_Modo1_A1): aristaA_opcion(1)
	elif(evt == EVENT_Modo1_A2): aristaA_opcion(2)
	elif(evt == EVENT_Modo1_A3): aristaA_opcion(3)

	elif(evt == EVENT_Modo1_B): aristaB()
	elif(evt == EVENT_Modo1_B0): aristaB_opcion(0)
	elif(evt == EVENT_Modo1_B1): aristaB_opcion(1)
	elif(evt == EVENT_Modo1_B2): aristaB_opcion(2)
	elif(evt == EVENT_Modo1_B3): aristaB_opcion(3)

	elif(evt == EVENT_Modo1_C0): opcion_interseccion()

	elif(evt == EVENT_DISTANCIA): pto_distancia()

	elif(evt == EVENT_ARISTA_AGREGAR): arista_agregar()
	elif(evt == EVENT_ARISTA_BORRAR): arista_borrar()

	elif(evt == EVENT_ARISTA_BO_NO): arista_inicial_borrar(0)
	elif(evt == EVENT_ARISTA_BO_SI): arista_inicial_borrar(1)

	elif(evt == EVENT_CANCEL): cancelar()
	elif(evt == EVENT_OK): aceptar()

Register(draw, event, bevent)


#######################################################
# Cuerpo Principal
#######################################################

def plano_opcion(iop):
	global I_Plano0,I_Plano1,I_Plano2,I_Plano3

	I_Plano0.val=I_Plano1.val=I_Plano2.val=I_Plano3.val=0
	
	if(iop==0): 
		I_Plano0.val=1
	elif(iop==1): 
		I_Plano1.val=1
	elif(iop==2): 
		I_Plano2.val=1
	elif(iop==3): 
		I_Plano3.val=1
	Blender.Redraw()

#--------------------------------------------------------------------------

def modo_opcion(iop):
	global I_Modo0,I_Modo1

	I_Modo0.val=I_Modo1.val=0

	if(iop==0):
		I_Modo0.val=1
	elif(iop==1):
		I_Modo1.val=1

	Blender.Redraw()

#--------------------------------------------------------------------------

def aristaA():
	global I_Modo1_A,I_Modo1_A0,I_Modo1_A1,I_Modo1_A2,I_Modo1_A3
	global I_Modo1_C0
	global I_Error_Sel
	global Ver_X3,Ver_Y3,Ver_Z3,Ver_X4,Ver_Y4,Ver_Z4	
	global Xv1,Yv1,Zv1,Xv2,Yv2,Zv2,Abertura

	arista_buscar()
	I_Modo1_A.val=0
	if(I_Error_Sel==1):
		Window.RedrawAll()
		return

	I_Modo1_A0.val=I_Modo1_A1.val=I_Modo1_A2.val=I_Modo1_A3.val=0
	I_Modo1_C0.val=0

	Ver_X3=Xv1
	Ver_Y3=Yv1
	Ver_Z3=Zv1
	Ver_X4=Xv2
	Ver_Y4=Yv2
	Ver_Z4=Zv2
	Window.RedrawAll()
	
#--------------------------------------------------------------------------

def aristaA_opcion(iop):
	global I_Modo1_A,I_Modo1_A0,I_Modo1_A1,I_Modo1_A2,I_Modo1_A3
	global I_Modo1_C0
	global Ver_X1,Ver_Y1,Ver_Z1,Ver_X2,Ver_Y2,Ver_Z2	
	global Ver_X3,Ver_Y3,Ver_Z3,Ver_X4,Ver_Y4,Ver_Z4	
	
	I_Modo1_A0.val=I_Modo1_A1.val=I_Modo1_A2.val=I_Modo1_A3.val=0
	I_Modo1_C0.val=0

	if(iop==0):
		I_Modo1_A0.val=1
		Pto_Ubicar(Ver_X1,Ver_Y1,Ver_Z1,Ver_X3,Ver_Y3,Ver_Z3)
	if(iop==1):
		I_Modo1_A1.val=1
		Pto_Ubicar(Ver_X1,Ver_Y1,Ver_Z1,Ver_X4,Ver_Y4,Ver_Z4)
	if(iop==2):
		I_Modo1_A2.val=1
		Pto_Ubicar(Ver_X1,Ver_Y1,Ver_Z1,(Ver_X3+Ver_X4)/2,
		(Ver_Y3+Ver_Y4)/2,(Ver_Z3+Ver_Z4)/2)
	if(iop==3):
		I_Modo1_A3.val=1
		Pto_Perpendicular(Ver_X3,Ver_Y3,Ver_Z3,Ver_X4,Ver_Y4,Ver_Z4)

	Blender.Redraw()

#--------------------------------------------------------------------------

def aristaB():
	global I_Modo1_B,I_Modo1_B0,I_Modo1_B1,I_Modo1_B2,I_Modo1_B3
	global I_Modo1_C0
	global I_Error_Sel
	global Ver_X5,Ver_Y5,Ver_Z5,Ver_X6,Ver_Y6,Ver_Z6	
	global Xv1,Yv1,Zv1,Xv2,Yv2,Zv2,Abertura

	arista_buscar()
	I_Modo1_B.val=0
	if(I_Error_Sel==1):
		Window.RedrawAll()
		return

	I_Modo1_B0.val=I_Modo1_B1.val=I_Modo1_B2.val=I_Modo1_B3.val=0
	I_Modo1_C0.val=0

	Ver_X5=Xv1
	Ver_Y5=Yv1
	Ver_Z5=Zv1
	Ver_X6=Xv2
	Ver_Y6=Yv2
	Ver_Z6=Zv2
	Window.RedrawAll()

#--------------------------------------------------------------------------

def aristaB_opcion(iop):
	global I_Modo1_B,I_Modo1_B0,I_Modo1_B1,I_Modo1_B2,I_Modo1_B3
	global I_Modo1_C0
	global Ver_X3D,Ver_Y3D,Ver_Z3D
	global Ver_X1,Ver_Y1,Ver_Z1,Ver_X2,Ver_Y2,Ver_Z2	
	global Ver_X5,Ver_Y5,Ver_Z5,Ver_X6,Ver_Y6,Ver_Z6	

	I_Modo1_B0.val=I_Modo1_B1.val=I_Modo1_B2.val=I_Modo1_B3.val=0
	I_Modo1_C0.val=0

	if(iop==0):
		I_Modo1_B0.val=1
		Pto_Ubicar(Ver_X1,Ver_Y1,Ver_Z1,Ver_X5,Ver_Y5,Ver_Z5)
	if(iop==1):
		I_Modo1_B1.val=1
		Pto_Ubicar(Ver_X1,Ver_Y1,Ver_Z1,Ver_X6,Ver_Y6,Ver_Z6)
	if(iop==2):
		I_Modo1_B2.val=1
		Pto_Ubicar(Ver_X1,Ver_Y1,Ver_Z1,(Ver_X5+Ver_X6)/2,
		(Ver_Y5+Ver_Y6)/2,(Ver_Z5+Ver_Z6)/2)
	if(iop==3):
		I_Modo1_B3.val=1
		Pto_Perpendicular(Ver_X5,Ver_Y5,Ver_Z5,Ver_X6,Ver_Y6,Ver_Z6)

	Blender.Redraw()

#--------------------------------------------------------------------------

def opcion_interseccion():
	global I_Plano0,I_Plano1,I_Plano2,I_Plano3
	global I_Modo1_A,I_Modo1_A0,I_Modo1_A1,I_Modo1_A2,I_Modo1_A3
	global I_Modo1_B,I_Modo1_B0,I_Modo1_B1,I_Modo1_B2,I_Modo1_B3
	global I_Modo1_C0
	global Ver_X3D,Ver_Y3D,Ver_Z3D
	global Ver_X1,Ver_Y1,Ver_Z1,Ver_X2,Ver_Y2,Ver_Z2	
	global Ver_X3,Ver_Y3,Ver_Z3,Ver_X4,Ver_Y4,Ver_Z4	
	global Ver_X5,Ver_Y5,Ver_Z5,Ver_X6,Ver_Y6,Ver_Z6	

	I_Modo1_A0.val=I_Modo1_A1.val=I_Modo1_A2.val=I_Modo1_A3.val=0
	I_Modo1_B0.val=I_Modo1_B1.val=I_Modo1_B2.val=I_Modo1_B3.val=0
	I_Modo1_C0.val=1

	x3=Ver_X3
	y3=Ver_Y3
	z3=Ver_Z3
	x4=Ver_X4
	y4=Ver_Y4
	z4=Ver_Z4
	x5=Ver_X5
	y5=Ver_Y5
	z5=Ver_Z5
	x6=Ver_X6
	y6=Ver_Y6
	z6=Ver_Z6
	if(I_Plano0==1): 
		z3=z4=z5=z6=Ver_Z1
	if(I_Plano1==1):
		y3=y4=y5=y6=Ver_Y1
	if(I_Plano2==1):
		x3=x4=x5=x6=Ver_X1
	interseccion3d(x3,y3,z3,x4,y4,z4,x5,y5,z5,x6,y6,z6)
	
	Blender.Redraw()
	
#--------------------------------------------------------------------------

def arista_inicial_borrar(iop):
	global I_Arista_Bo_No,I_Arista_Bo_Si

	I_Arista_Bo_No.val=I_Arista_Bo_Si.val=0

	if(iop==0):
		I_Arista_Bo_No.val=1
	if(iop==1):
		I_Arista_Bo_Si.val=1
	
	Blender.Redraw()
	
#--------------------------------------------------------------------------
			
def arista_buscar():
	global I_Error_Sel
	global sX00,sY00,m_MatPerp,m_MatView,m_MatObj
	global Xv1,Yv1,Zv1,Xv2,Yv2,Zv2,Abertura
	global Ver_X3D,Ver_Y3D,Ver_Z3D
	
	selection = Blender.Object.GetSelected()
	k=len(selection)
	if(k > 0): 
		ob=selection[0]
		if(ob.type != 'Mesh'): k=0

	if k < 1:
		Blender.Draw.PupMenu( 'ERROR: No existe Malla Seleccionada' )
		I_Error_Sel=1
		return

	# Busca Punto en Borde	
	Pto_Pantalla()
	if(I_Error_Sel == 1):
		Blender.Draw.PupMenu( 'ERROR: Arista No Seleccionada' )
		I_Error_Sel=1
		return
	
	# Transforma Coordenadas de Objeto Seleccionado de 3D a 2D
	mesh=ob.getData()
	me=Mesh.Get(mesh.name)
	m_MatObj=ob.getMatrix()
	
	abert0=-1
	for ed in me.edges:
		n1=ed.v1.index
		n2=ed.v2.index
		x01=me.verts[n1].co[0]
		y01=me.verts[n1].co[1]
		z01=me.verts[n1].co[2]
		x02=me.verts[n2].co[0]
		y02=me.verts[n2].co[1]
		z02=me.verts[n2].co[2]
		pto1=transWC2SC(x01,y01,z01)
		pto2=transWC2SC(x02,y02,z02)
		d0=dist_pto_recta3D(sX00,sY00,0,pto1[0],pto1[1],0,pto2[0],pto2[1],0,1)
		if(d0 <= Abertura and d0 >= 0):
			if(abert0 < 0 or d0 < abert0):
				abert0=d0
				Xv1=x01
				Yv1=y01
				Zv1=z01
				Xv2=x02
				Yv2=y02
				Zv2=z02
		
	if(abert0 < 0):
		Blender.Draw.PupMenu( 'ERROR: Arista No Proxima' )
		I_Error_Sel=1
		return
	
	# Transforma Coordenadas Locales a Globales
	co1 = Blender.Mathutils.Vector(Xv1,Yv1,Zv1,1.0)
	co2 = co1*m_MatObj
	Xv1=co2[0]
	Yv1=co2[1]
	Zv1=co2[2]
	co1 = Blender.Mathutils.Vector(Xv2,Yv2,Zv2,1.0)
	co2 = co1*m_MatObj
	Xv2=co2[0]
	Yv2=co2[1]
	Zv2=co2[2]
	
	# Dibuja Cursor 3D en punto medio
	
	Ver_X3D=(Xv1+Xv2)/2
	Ver_Y3D=(Yv1+Yv2)/2
	Ver_Z3D=(Zv1+Zv2)/2
	Window.SetCursorPos(Ver_X3D,Ver_Y3D,Ver_Z3D)
	Window.Redraw()

#--------------------------------------------------------------------------

# Transforma Coordenadas de Objeto Seleccionado de 3D a 2D (pantalla)
def transWC2SC(wc_x,wc_y,wc_z):
	global m_MatPerp,m_MatView,m_MatObj
	global w_minX,w_minY,w_maxX,w_maxY

	mid_x = (w_maxX + w_minX)/2.0
	mid_y = (w_maxY + w_minY)/2.0
	width = (w_maxX - w_minX + 1.0)
	height= (w_maxY - w_minY + 1.0)
      
	coords = Blender.Mathutils.Vector(wc_x,wc_y,wc_z,1.0)

	val = coords*m_MatObj*m_MatPerp
	val = dehom(val)

	val[0] = mid_x+ val[0]*width/2.0
	val[1] = mid_y + val[1]*height/2.0
	val[2] =  (val[2]+1)/2
                         
	return val

#--------------------------------------------------------------------------

def dehom(v):
	ret = Vector(v[0]/v[3],v[1]/v[3],v[2]/v[3])
	return ret

#--------------------------------------------------------------------------

# Calcula distancia desde pto a recta. Si op=1 verifica que el pto de interseccion 
# entre Pto0 y recta esta entre Pto1 y Pto2
def dist_pto_recta3D(x0,y0,z0,x1,y1,z1,x2,y2,z2,op):
	global Xper,Yper,Zper
	
	x21=x2-x1
	y21=y2-y1
	z21=z2-z1
	x10=x1-x0
	y10=y1-y0
	z10=z1-z0
	
	x210=y21*z10-y10*z21
	y210=z21*x10-z10*x21
	z210=x21*y10-x10*y21

	d0=x210*x210+y210*y210+z210*z210
	d1=x21*x21+y21*y21+z21*z21
	if d1 < 0.001:
		return -1
	di= sqrt(d0/d1)
	if(op == 0): return di
	
	di10=dist_2ptos(x1,y1,z1,x0,y0,z0)
	di20=dist_2ptos(x2,y2,z2,x0,y0,z0)
	di21=dist_2ptos(x2,y2,z2,x1,y1,z1)
	if(di > 0.001):
		c10=sqrt(di10*di10-di*di)
		c20=sqrt(di20*di20-di*di)
	else:
		c10=di10
		c20=di20
	if(c20 > di21): dd=(di21-c20)/di21 
	else: dd=c10/di21
	Xper=x1+x21*dd
	Yper=y1+y21*dd
	Zper=z1+z21*dd
	print "c10,c20",c10,c20,di21
	print x1,y1,z1,x2,y2,z2
	print x21,y21,z21
	print "per  ",Xper,Yper,Zper
	if(c10 > di21+0.001 or c20 > di21+0.001): return -2
	return di

#-------------------------------------------------------------------------------------

# Distancia entre dos puntos
def dist_2ptos(x1,y1,z1,x2,y2,z2):
	x21=x2-x1
	y21=y2-y1
	z21=z2-z1
	return sqrt(x21*x21+y21*y21+z21*z21)

#-------------------------------------------------------------------------------------

def Pto_Pantalla():
	global I_Error_Sel
	global sX00,sY00,m_MatPerp,m_MatView
	global w_minX,w_minY,w_maxX,w_maxY
		
	done = 0
	I_Error_Sel=1
	
	ii=0
	while not done:  # enter a 'get event' loop
		evt, val = Window.QRead() # catch next event
		if(ii<2):
			ii+=1
			continue
			
		if evt in [Blender.Draw.MOUSEX, Blender.Draw.MOUSEY]:
			continue # speeds things up, ignores mouse movement

		elif evt in [Blender.Draw.ESCKEY, Blender.Draw.QKEY]: 
			done = 1 # end loop

#		elif evt == Blender.Draw.SPACEKEY:
#			Blender.Draw.PupMenu("Hey!|What did you expect?")

#		elif evt == Blender.Draw.Redraw: # catch redraw events to handle them
#			Window.RedrawAll() # redraw all areas

		elif evt == Blender.Draw.LEFTMOUSE: # left button pressed
			done = 1
			sX00,sY00=Window.GetMouseCoords()

			for win3d in Window.GetScreenInfo(Window.Types.VIEW3D):
				w_minX,w_minY,w_maxX,w_maxY=win3d['vertices']
				if(w_minX <= sX00 and sX00 <= w_maxX and w_minY <= sY00 and sY00 <= w_maxY):
					I_Error_Sel=0
					id = win3d['id']
					Window.QAdd(id, evt, 1) # add the caught mouse event to our v3d
					Window.QHandle(id) # process the event
					Window.GetViewQuat()
					m_MatPerp=Window.GetPerspMatrix()
					m_MatView=Window.GetViewMatrix()
					Window.RedrawAll()
					return

#--------------------------------------------------------------------------
	
def arista_agregar():
	global Ver_X1,Ver_Y1,Ver_Z1,Ver_X2,Ver_Y2,Ver_Z2	
	global MallaC,obMallaC
	global I_Vert_Last
	
	me=Mesh.Get(MallaC.name)
	nverts=len(me.verts)

	# Busca vertice existente
	i=0
	while i < nverts:
		x01=me.verts[i].co[0]
		y01=me.verts[i].co[1]
		z01=me.verts[i].co[2]
		iab0=abs(Ver_X3D-x01)+abs(Ver_Y3D-y01)+abs(Ver_Z3D-z01)
		if(iab0 < 0.0001):
			break
	
		i+=1

	if(i >= nverts): MallaC.verts.extend(Ver_X3D,Ver_Y3D,Ver_Z3D)
	MallaC.edges.extend(I_Vert_Last,i)
	I_Vert_Last=i
	Ver_X1=Ver_X3D
	Ver_Y1=Ver_Y3D
	Ver_Z1=Ver_Z3D

	obs = [ob for ob in scn.objects if ob.name == obMallaC.name]
	scn.objects.selected = obs
	
	Window.RedrawAll()

#--------------------------------------------------------------------------
	
def arista_borrar():
	global Ver_X1,Ver_Y1,Ver_Z1,Ver_X2,Ver_Y2,Ver_Z2	
	global MallaC,obMallaC
	global I_Vert_Last

	Scene.GetCurrent().objects.selected= [] 
	obs = [ob for ob in scn.objects if ob.name == obMallaC.name]

	if(len(obs) < 1):
		Blender.Draw.PupMenu( 'ERROR: Objeto no seleccionado' )
		return
		
	ob=obs[0]
	mesh=ob.getData()
	me=Mesh.Get(mesh.name)
	nedges=len(me.edges)

	if nedges < 2: 	
		Blender.Draw.PupMenu( 'ADVERTENCIA: Objeto tiene menos de 2 aristas' )
		return

	n1=me.edges[nedges-1].v1.index
	Ver_X1=me.verts[n1].co[0]
	Ver_Y1=me.verts[n1].co[1]
	Ver_Z1=me.verts[n1].co[2]
	I_Vert_Last=n1

	me.edges.delete(nedges-1)
	
	scn.objects.selected = obs

	Blender.Redraw()
			

#--------------------------------------------------------------------------

def pto_xyz():
	global Ver_X1,Ver_Y1,Ver_Z1,Ver_X2,Ver_Y2,Ver_Z2	
	global S_Des_X,S_Des_Y,S_Des_Z

	Ver_X2a=Ver_X1+float(S_Des_X.val)
	Ver_Y2a=Ver_Y1+float(S_Des_Y.val)
	Ver_Z2a=Ver_Z1+float(S_Des_Z.val)

	Pto_Ubicar(Ver_X1,Ver_Y1,Ver_Z1,Ver_X2a,Ver_Y2a,Ver_Z2a)

#--------------------------------------------------------------------------

def Pto_Ubicar(vX1,vY1,vZ1,vX2,vY2,vZ2):
	global I_Plano0,I_Plano1,I_Plano2,I_Plano3
	global S_Des_Dis
	global Ver_X1,Ver_Y1,Ver_Z1,Ver_X2,Ver_Y2,Ver_Z2	
	global Ver_X3D,Ver_Y3D,Ver_Z3D
	global vDX,vDY,vDZ

	DX0=vX2-vX1
	DY0=vY2-vY1
	DZ0=vZ2-vZ1
	if(I_Plano0==1): DZ0=0
	if(I_Plano1==1): DY0=0
	if(I_Plano2==1): DX0=0
	if(abs(DX0)+abs(DY0)+abs(DZ0) < 0.001):
		Blender.Draw.PupMenu( 'ERROR: Punto Invalido' )
		return
		
	vDX=DX0
	vDY=DY0
	vDZ=DZ0
	Ver_X2=vX2
	Ver_Y2=vY2
	Ver_Z2=vZ2
	if(I_Plano0==1): Ver_Z2=vZ1
	if(I_Plano1==1): Ver_Y2=vY1
	if(I_Plano2==1): Ver_X2=vX1
	Ver_X3D=Ver_X2
	Ver_Y3D=Ver_Y2
	Ver_Z3D=Ver_Z2
	Window.SetCursorPos(Ver_X3D,Ver_Y3D,Ver_Z3D)
	S_Des_Dis.val=str(dist_2ptos(vX1,vY1,vZ1,Ver_X3D,Ver_Y3D,Ver_Z3D))
	
	Blender.Redraw()

#--------------------------------------------------------------------------
	
def cancelar():
	global MallaC,obMallaC

	Scene.GetCurrent().objects.selected= [] 
	obs = [ob for ob in scn.objects if ob.name == obMallaC.name]
	if(len(obs) > 0):
		Scene.GetCurrent().objects.unlink(obs[0])
	Window.RedrawAll()
		
	Exit()

#--------------------------------------------------------------------------
	
def aceptar():
	global MallaC,obMallaC
	global S_Des_Dis,S_Nombre
	global I_Arista_Bo_No,I_Arista_Bo_Si

	Scene.GetCurrent().objects.selected= [] 
	obs = [ob for ob in scn.objects if ob.name == obMallaC.name]
	ob=obs[0]
	mesh=ob.getData()
	me=Mesh.Get(mesh.name)
	nedges=len(me.edges)
	if(nedges < 1 or (I_Arista_Bo_Si == 1 and nedges < 2)): cancelar() 
	if(I_Arista_Bo_Si == 1):
		me.edges.delete(0)
	ob.name=S_Nombre.val

	Exit()

#--------------------------------------------------------------------------

def pto_distancia():
	global I_Plano0,I_Plano1,I_Plano2,I_Plano3
	global Ver_X3D,Ver_Y3D,Ver_Z3D
	global vDX,vDY,vDZ
	global S_Des_Dis

	d0=float(S_Des_Dis.val)
	if(abs(d0) < 0.001):
		Blender.Draw.PupMenu( 'ERROR: Distancia Invalida' )
		return
	
	DX0=vDX
	DY0=vDY
	DZ0=vDZ
	if(I_Plano0==1): DZ0=0
	if(I_Plano1==1): DY0=0
	if(I_Plano2==1): DX0=0
	di=dist_2ptos(0,0,0,DX0,DY0,DZ0)	
	if(di >= 0.001):
		Ver_X3D= Ver_X1+vDX*d0/di
		Ver_Y3D= Ver_Y1+vDY*d0/di
		Ver_Z3D= Ver_Z1+vDZ*d0/di
		Window.SetCursorPos(Ver_X3D,Ver_Y3D,Ver_Z3D)
		Blender.Redraw()
	
#--------------------------------------------------------------------------

def Pto_Perpendicular(vX1,vY1,vZ1,vX2,vY2,vZ2):
	global I_Plano0,I_Plano1,I_Plano2,I_Plano3
	global Ver_X1,Ver_Y1,Ver_Z1,Ver_X2,Ver_Y2,Ver_Z2	
	global Ver_X3D,Ver_Y3D,Ver_Z3D
	global Xper,Yper,Zper

	x1=vX1
	y1=vY1
	z1=vZ1
	x2=vX2
	y2=vY2
	z2=vZ2
	if(I_Plano0==1): 
		z1=z2=Ver_Z1
	if(I_Plano1==1):
		y1=y2=Ver_Y1
	if(I_Plano2==1):
		x1=x2=Ver_X1
		
	di=dist_pto_recta3D(Ver_X1,Ver_Y1,Ver_Z1,x1,y1,z1,x2,y2,z2,1)
	if(abs(di) < 0.001):
		Blender.Draw.PupMenu( 'ERROR: Arista es colineal a vertice' )
		return

	Pto_Ubicar(Ver_X1,Ver_Y1,Ver_Z1,Xper,Yper,Zper)
	
#--------------------------------------------------------------------------

def	interseccion3d(xa1,ya1,za1,xa2,ya2,za2,xb1,yb1,zb1,xb2,yb2,zb2):
	global Ver_X1,Ver_Y1,Ver_Z1,Ver_X2,Ver_Y2,Ver_Z2	

	dxa=xa2-xa1
	dya=ya2-ya1
	dza=za2-za1
	print "da ",dxa,dya,dza

	dxb=xb2-xb1
	dyb=yb2-yb1
	dzb=zb2-zb1
	print "dB ",dxb,dyb,dzb

	o2o1x=xb1-xa1
	o2o1y=yb1-ya1
	o2o1z=zb1-za1
	print "do2o1 ",o2o1x,o2o1y,o2o1z
	
	d1d2x,d1d2y,d1d2z=prodvec(dxa,dya,dza,dxb,dyb,dzb)
	de1=deter33(o2o1x,dxb,d1d2x,o2o1y,dyb,d1d2y,o2o1z,dzb,d1d2z)
	de2=deter33(o2o1x,dxa,d1d2x,o2o1y,dya,d1d2y,o2o1z,dza,d1d2z)
	d1d2=norma(d1d2x,d1d2y,d1d2z)

	if(d1d2 < 0.001):
		Blender.Draw.PupMenu( 'ERROR: Aristas paralelas' )
		return
	
	t1=de1/d1d2/d1d2
	t2=de2/d1d2/d1d2
	
	xai=xa1+dxa*t1
	yai=ya1+dya*t1
	zai=za1+dza*t1
	
	xbi=xb1+dxb*t2
	ybi=yb1+dyb*t2
	zbi=zb1+dzb*t2
	
	if(abs(xai-xbi)+abs(yai-ybi)+abs(yai-ybi) > 0.001):
		Blender.Draw.PupMenu( 'ERROR: Aristas no se intersectan' )
		return

	Pto_Ubicar(Ver_X1,Ver_Y1,Ver_Z1,xai,yai,zai)
	
#--------------------------------------------------------------------------

def prodvec(a11,a12,a13,a21,a22,a23):

	b11=a12*a23-a22*a13
	b12=-a11*a23+a13*a21
	b13=a11*a22-a12*a21
	return b11,b12,b13
	
#--------------------------------------------------------------------------

def deter33(a11,a12,a13,a21,a22,a23,a31,a32,a33):

	b1=a11*(a22*a33-a32*a23)
	b2=-a12*(a21*a33-a23*a31)
	b3=a13*(a21*a32-a22*a31)
	return b1+b2+b3
	
#--------------------------------------------------------------------------

def norma(a11,a12,a13):

	return sqrt(a11*a11+a12*a12+a13*a13)

	
#--------------------------------------------------------------------------

